$(document).ready(function () {
	//#######################################

	const graphArray = [
	["ASPO - Datini", "http://dev.restore.ovi.cnr.it:8890/aspo/datini"], 
	["ASPO - Ospedale", "http://dev.restore.ovi.cnr.it:8890/aspo/ospedale"],
	["ASPO - Marcovaldi", "http://dev.restore.ovi.cnr.it:8890/aspo/marcovaldi"],
	["ASPO - Gettatelli", "http://dev.restore.ovi.cnr.it:8890/aspo/gettatelli"],
	["ASPO - Autori ASPO", "http://dev.restore.ovi.cnr.it:8890/aspo/actors"],
	["MPP - Collezione Martini", "http://dev.restore.ovi.cnr.it:8890/mpp/martini"],
	["MPP - Collezione Ospedale", "http://dev.restore.ovi.cnr.it:8890/mpp/ospedale"],
	["MPP - Collezione Datini", "http://dev.restore.ovi.cnr.it:8890/mpp/datini"],
	["OVI - Lettere", "http://dev.restore.ovi.cnr.it:8890/ovi/datini"],
	["Luoghi", "http://dev.restore.ovi.cnr.it:8890/mpp/places"]
	];

	var graph_selector = document.getElementById("graph_selector");

	let x = graphArray.length;

	for(var i=0; i<x; i++) {
		   var opt = document.createElement("option");
		   opt.value= graphArray[i][1];
		   opt.innerHTML = graphArray[i][0]; // whatever property it has

		   // then append it to the select element
		   graph_selector.add(opt);
		}

	var search_name = "";
	var testo = "";

	function results_retrieveData() {

		search_name = testo;

		var g = document.getElementById("graph_selector");
		var graph = g.value;

		var search_graph = "?g";
		var gg = "?g";

		if (graph != "") {
			search_graph = '<' + graph + '>';
			gg = "";
		} 


		//var query='SELECT DISTINCT ?nome WHERE {  ?autore <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> <http://www.cidoc-crm.org/cidoc-crm/E39_Actor> .   ?autore <http://www.cidoc-crm.org/cidoc-crm/P1_is_identified_by> ?nomeid.   ?nomeid <http://www.w3.org/2000/01/rdf-schema#label> ?nome . FILTER regex(?nome, "'+ search_name +'") }' ;
		prefixes = "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#> \
		PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> \
		PREFIX crm: <http://www.cidoc-crm.org/cidoc-crm/>"

		queryMMO = prefixes + " SELECT DISTINCT "+ search_graph +" AS ?graph ?subject ?label (group_concat(distinct ?type ;separator=', ') as ?types) (group_concat(distinct ?id ;separator=' - ') as ?identifiers) \
		WHERE {GRAPH "+ search_graph +" { ?subject ?property ?object } \
		?subject rdf:type crm:E22_Man-Made_Object . \
		OPTIONAL {?subject crm:P2_has_type ?type } \
		OPTIONAL {?subject crm:P1_is_identified_by ?uri_id . \
		?uri_id rdfs:label ?id . } \
		{?subject rdfs:label ?label . \
		?label bif:contains  \"\' "+ search_name + " \'\"  . \
		} UNION { \
		?subject crm:P1_is_identified_by ?uri_id ; \
		rdfs:label ?label . \
		?uri_id rdfs:label ?id . \
		?id bif:contains \"\' "+ search_name + " \'\"  } \
		} ORDER BY ?types"

		queryInfObj = prefixes + " SELECT DISTINCT "+ search_graph +" AS ?graph ?Physical_Object ?subject ?label ?id (group_concat(distinct ?type ;separator=', ') as ?types) (SAMPLE(?object_Label) AS ?text) \
		WHERE { \
		GRAPH "+ search_graph +" {?subject rdf:type crm:E73_Information_Object ; \
		rdfs:label ?label .} \
		OPTIONAL {?Physical_Object crm:P128_carries ?subject .} \
		OPTIONAL {?subject crm:P1_is_identified_by ?id_subject . \
		?id_subject rdfs:label ?id ; \
		rdf:type crm:E42_Identifier . } \
		OPTIONAL {?subject crm:P2_has_type ?entity_type . \
		?entity_type rdfs:label ?type .} \
		{?subject ?property ?object_Label . \
		?object_Label bif:contains \"\' "+ search_name + " \'\" . \
		} UNION { \
        VALUES ?object_type {crm:E1_Entity crm:E1_CRM_Entity crm:E41_Appellation crm:E62_String} \
		?subject ?property ?object  . \
		?object rdfs:label ?object_Label . \
		?object rdf:type ?object_type . \
		?object_Label bif:contains \"\' "+ search_name + " \'\" . \
		} \
		FILTER NOT EXISTS { ?property rdfs:label 'label' } \
		} ORDER BY ?id ?types"

		queryPerson = prefixes + " SELECT DISTINCT "+ search_graph +" AS ?graph ?subject ?name ?label \
		WHERE {GRAPH "+ search_graph +" { ?subject ?property ?object } \
		?subject rdfs:label ?label; \
                rdf:type crm:E21_Person ; \
                foaf:name ?name . \
		?label bif:contains \"\' "+ search_name + " \'\" . \
		}"

		queryPlace = prefixes + " SELECT DISTINCT "+ search_graph +" AS ?graph ?subject ?label \
		WHERE {GRAPH "+ search_graph +" { ?subject ?property ?object } \
		{?subject rdfs:label ?label ; \
		rdf:type crm:E53_Place ; \
		crm:P168_place_is_defined_by ?coords . \
		?label bif:contains \"\' "+ search_name + " \'\"  . \
		} UNION { \
		?subject crm:P1_is_identified_by ?toponimo . \
		?toponimo crm:P2_has_type 'Toponimo' ; \
		rdfs:label ?label . \
		?label bif:contains \"\' "+ search_name + " \'\"  . \
		} \
		}"


		//query = 'SELECT DISTINCT '+ search_graph +' AS ?graph ?link ?label ?entity ?object ?objLab WHERE { GRAPH '+ search_graph +' { ?link <http://www.w3.org/2000/01/rdf-schema#label> ?label ; <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> '+ search_entity +' . ?label bif:contains "\'' + search_name + '\'" .} '+ search_entity +' <http://www.w3.org/2000/01/rdf-schema#label> ?entity . FILTER (langMatches( lang(?entity), "en" )) OPTIONAL {?link <http://www.cidoc-crm.org/cidoc-crm/P2_has_type> ?object } OPTIONAL {?link <http://www.cidoc-crm.org/cidoc-crm/P2_has_type> ?link_object . ?link_object <http://www.w3.org/2000/01/rdf-schema#label> ?objLab }} limit 100';
       
		var ManMadeObject_url = 'http://dev.restore.ovi.cnr.it:8890/sparql/?default-graph-uri=&query=' + encodeURIComponent(queryMMO) + '&output=json';

		var InformationObject_url = 'http://dev.restore.ovi.cnr.it:8890/sparql/?default-graph-uri=&query=' + encodeURIComponent(queryInfObj) + '&output=json';

		var Persons_url = 'http://dev.restore.ovi.cnr.it:8890/sparql/?default-graph-uri=&query=' + encodeURIComponent(queryPerson) + '&output=json';

		var Places_url = 'http://dev.restore.ovi.cnr.it:8890/sparql/?default-graph-uri=&query=' + encodeURIComponent(queryPlace) + '&output=json';

		$.ajax({

			url: ManMadeObject_url + '&callback=?',
			dataType: "json",
			success: function (data) {
				MMO_handle_json(data);
			},
			error: function (e) {}
		});


		$.ajax({

			url: InformationObject_url + '&callback=?',
			dataType: "json",
			success: function (data) {
				InfObj_handle_json(data);
			},
			error: function (e) {}
		});

		$.ajax({

			url: Persons_url + '&callback=?',
			dataType: "json",
			success: function (data) {
				Person_handle_json(data);
			},
			error: function (e) {}
		});

		$.ajax({

			url: Places_url + '&callback=?',
			dataType: "json",
			success: function (data) {
				Place_handle_json(data);
			},
			error: function (e) {}
		});

	}

	function rewrite_graph(graph) {

		var graph_name = ""

		if (graph == "http://dev.restore.ovi.cnr.it:8890/aspo/datini") {
			graph_name = "Archivio di Stato di Prato"; 
		}
		else if (graph == "http://dev.restore.ovi.cnr.it:8890/aspo/ospedale") {
			graph_name = "Archivio di Stato di Prato";
		}
		else if (graph ==  "http://dev.restore.ovi.cnr.it:8890/aspo/marcovaldi") {
			graph_name = "Archivio di Stato di Prato";
		}
		else if (graph ==  "http://dev.restore.ovi.cnr.it:8890/aspo/gettatelli") {
			graph_name = "Archivio di Stato di Prato";
		}
		else if (graph ==  "http://dev.restore.ovi.cnr.it:8890/aspo/actors") {
			graph_name = "Archivio di Stato di Prato";
		}
		else if (graph ==  "http://dev.restore.ovi.cnr.it:8890/mpp/martini") {
			graph_name = "Museo di Palazzo Pretorio di Prato";
		}
		else if (graph ==  "http://dev.restore.ovi.cnr.it:8890/mpp/ospedale") {
			graph_name = "Museo di Palazzo Pretorio di Prato";
		}
		else if (graph ==  "http://dev.restore.ovi.cnr.it:8890/mpp/datini") {
			graph_name = "Museo di Palazzo Pretorio di Prato";
		}
		else if (graph ==  "http://dev.restore.ovi.cnr.it:8890/mpp/authors") {
			graph_name = "Museo di Palazzo Pretorio di Prato";
		}
		else if (graph ==  "http://dev.restore.ovi.cnr.it:8890/ovi/datini") {
			graph_name = "Opera del Vocabolario Italiano";
		}
		else if (graph ==  "http://dev.restore.ovi.cnr.it:8890/ovi/datini/trascr") {
			graph_name = "Opera del Vocabolario Italiano";
		}
		else if (graph ==  "http://dev.restore.ovi.cnr.it:8890/places") {
			graph_name = "Luoghi";
		}
		else if (graph ==  "http://dev.restore.ovi.cnr.it:8890/mpp/places") {
			graph_name = "Museo di Palazzo Pretorio di Prato";
		}
		else if (graph ==  "http://dev.restore.ovi.cnr.it:8890/label/toponimi") {
			graph_name = "Toponimi Archivio di Stato di Prato";
		}
		else if (graph ==  "http://dev.restore.ovi.cnr.it:8890/aspo/onomastica") {
			graph_name = "Onomastica Datini";
		}
		else {graph_name = graph;
		}

		return graph_name;
	}

	function MMO_handle_json(json) {

		console.log(json); 

		$('#wb_Shape1').text("");
		$('#wb_Image1').text("");
		$('#Man-Made_Object').text("");
		$(".results").css("display", "block");
		$('#n_mmo').text("");

		var i = 0;

		$.each(
			json['results']['bindings'],
			function (index, value) {
				var object = ""; /*Inserisci VALUE TIPOLOGIA*/

				var graph = value['graph']['value'];
				var graph_name = rewrite_graph(graph);
				var mmoType = "";
				var mmoId = "";
				var object_button = "";

				if (value.hasOwnProperty('types')) {
						mmoType = value['types']['value'];
					}

				if (value.hasOwnProperty('identifiers')) {
						mmoId = value['identifiers']['value'];
					}
				
				if (mmoType.includes("Opera d'Arte")) {
					object_button  += '<button type="button" id="' + value['subject']['value'] + 
					'" class="artwork btn btn-default" alt="opera d\'arte" title="' + value['label']['value'] + 
					'"><i class="fas fa-paint-brush"></i><p class="btn-text">Scheda Opera d\'Arte</p></button>';
				} else {
					object_button  += '<button type="button" id="' + value['subject']['value'] + 
					'" class="object btn btn-default" alt="oggetto" title="' + value['label']['value'] + 
					'"><i class="fa fa-book"></i><p class="btn-text">Scheda Oggetto</p></button>';
				}

				object += /*INIZIO DIV*/ '<div class="row res"><div class="col-8">' + graph_name + '<br />' +
				'<a href=' + value['subject']['value'] + ' target="_blank">' + value['label']['value'] + '</a><br />' +
				'<i>' + mmoType + ' ' + mmoId + '</i></div>' +
				'<div class="col">' + object_button + '</div>' +
				'<div class="col"><button type="button" id="' + value['subject']['value'] + '" class="cit btn btn-default" alt="scheda" title="Info"><i class="fa fa-quote-right"></i><p class="btn-text">Citazione</p></button></div>' +
				/*DA QUI HYPERLINK ->*/'<div class="col"><button type="button" id="' + value['subject']['value'] + '" class="hyp btn btn-default" alt="scheda" title="Info"><i class="fa fa-link"></i><p class="btn-text">Hyperlink</p></button></div>' +
				/*DA QUI LOD ->*/'<div class="col"><a href="http://dev.restore.ovi.cnr.it/lodlive/?' + value['subject']['value'] + '" target="_blank"><button type="button" class="btn btn-default info" alt="LOD"><i class="fa fa-share-alt"></i><p class="btn-text">Lod</p></button></a></div></div>'; 

				i++;

				/*onclick=copy__Text("' + value['link']['value'] + '")*/

				$('#Man-Made_Object').append(object);

			});

		$('#n_mmo').append(i);

		if (i==0) {
			var message = '<p>Nessun Oggetto Fisico trovato</p>';
			$('#Man-Made_Object').append(message);
		}

	}

	function InfObj_handle_json(json) {

		console.log(json); 

		$('#Information_Object').text("");
		$('#n_io').text("");

		var i = 0;

		$.each(
			json['results']['bindings'],
			function (index, value) {
				var information = ""; /*Inserisci VALUE TIPOLOGIA*/

				var graph = value['graph']['value'];
				var graph_name = rewrite_graph(graph);

				var tipo = "";
				var id = "";
				var infObject_button = "";

				var myString = value['text']['value'];
				var str = myString.replace(/<[^>]*>?/gm, '');
				let string_text = str.toLowerCase();
				let string_len = str.length;
				var word = testo;
				let ind = string_text.indexOf(word);
				let length = word.length;
				var wl = ind + length;
				/*var start = 0;
				var end = 0

				var bb = pp - 50;
				var ee = pp + length + 150;*/

				var pp = ind;
				before = str.substring(0, ind);
				after = str.substring(wl, string_len);

				let bb = before.lastIndexOf(".");
				let point = bb + pp;
				let ee = str.indexOf(".", point);
				
				console.log(bb, ee);
				
				if (bb < 0) {
					start = 0;
				} else {
					start = bb+1;
				}

				if (ee < 0) {
					end = string_len;
				} else {
					end = ee;
				}

				console.log(start, bb, end, ee);
				

				/*if (bb<=0) {
						start = 0;
				} else {
						start = bb;
				}


				if (ee>=string_len) {
						end = string_len;
				} else {
						end = ee;
				}*/

				first_chunk = str.substring(start, ind);
				highlight = str.substring(ind, wl);
				second_chunk = str.substring(wl, end);

				var snippet = first_chunk + "<span class='sharp'>" + highlight + "</span>" + second_chunk ;

				console.log(snippet);

				if (value.hasOwnProperty('types')) {
						tipo = value['types']['value'];
					}

				if (value.hasOwnProperty('id')) {
						id = " (" + value['id']['value'] + ")";
					}
				
				if (tipo.includes("lettera")) {
					infObject_button  += '<button type="button" id="' + value['subject']['value'] + 
					'" class="lettera btn btn-default" alt="lettera" title="' + value['label']['value'] + 
					'"><i class="fa fa-envelope"></i><p class="btn-text">Scheda Lettera</p></button>';
				} else {
					infObject_button  += '<button type="button" id="' + value['Physical_Object']['value'] + 
					'" class="object btn btn-default" alt="oggetto" title="' + value['label']['value'] + 
					'"><i class="fa fa-book"></i><p class="btn-text">Scheda Oggetto</p></button>';
				}


				information += /*INIZIO DIV*/ '<div class="row res"><div class="col-8"><p>'+ snippet+'</p>' + 
				'In: ' + graph_name + ';<br />' +
				'<a href=' + value['subject']['value'] + ' target="_blank">' + value['label']['value'] + id + 
				'</a>;<br /><i>' + tipo + '</i><br /></div>' + 
				'<div class="col">' + infObject_button + '</div>' +
				'<div class="col"><button type="button" id="' + value['subject']['value'] + '" class="cit btn btn-default" alt="scheda" title="Info"><i class="fa fa-quote-right"></i><p class="btn-text">Citazione</p></button></div>' +
				/*DA QUI HYPERLINK ->*/'<div class="col"><button type="button" id="' + value['subject']['value'] + '" class="hyp btn btn-default" alt="scheda" title="Info"><i class="fa fa-link"></i><p class="btn-text">Hyperlink</p></button></div>' +
				/*DA QUI LOD ->*/'<div class="col"><a href="http://dev.restore.ovi.cnr.it/lodlive/?' + value['subject']['value'] + '" target="_blank"><button type="button" class="btn btn-default info" alt="LOD"><i class="fa fa-share-alt"></i><p class="btn-text">Lod</p></button></a></div></div>'; 

				i++;

				/*onclick=copy__Text("' + value['link']['value'] + '")*/

				$('#Information_Object').append(information);

			});

		$('#n_io').append(i);

		if (i==0) {
			var message = '<p>Nessun Oggetto Informativo trovato</p>';
			$('#Information_Object').append(message);
		}

	}

	function Person_handle_json(json) {

		console.log(json); 

		$('#Person').text("");
		$('#n_ps').text("");
		
		var i = 0;

		$.each(
			json['results']['bindings'],
			function (index, value) {
				var person = ""; /*Inserisci VALUE TIPOLOGIA*/
				var graph = value['graph']['value'];
				var graph_name = rewrite_graph(graph);

				person += /*INIZIO DIV*/ '<div class="row res"><div class="col-8">' + graph_name + '<br />' +
				'<a href=' + value['subject']['value'] + ' target="_blank">' + value['name']['value'] + '</a></div>' +
				'<div class="col"><button type="button" id="' + value['subject']['value'] + '" class="persona btn btn-default" alt="persona" title="' + 
				value['name']['value'] + '"><i class="fa fa-user"></i><p class="btn-text">Scheda Persona</p></button></div>' +
				'<div class="col"><button type="button" id="' + value['subject']['value'] + '" class="cit btn btn-default" alt="scheda" title="Info"><i class="fa fa-quote-right"></i><p class="btn-text">Citazione</p></button></div>' +
				/*DA QUI HYPERLINK ->*/'<div class="col"><button type="button" id="' + value['subject']['value'] + '" class="hyp btn btn-default" alt="scheda" title="Info"><i class="fa fa-link"></i><p class="btn-text">Hyperlink</p></button></div>' +
				/*DA QUI LOD ->*/'<div class="col"><a href="http://dev.restore.ovi.cnr.it/lodlive/?' + value['subject']['value'] + '" target="_blank"><button type="button" class="btn btn-default info" alt="LOD"><i class="fa fa-share-alt"></i><p class="btn-text">Lod</p></button></a></div></div>'; 

				i++;

				/*onclick=copy__Text("' + value['link']['value'] + '")*/

				$('#Person').append(person);

			});

		$('#n_ps').append(i);

		if (i==0) {
			var message = '<p>Nessuna Persona trovata</p>';
			$('#Person').append(message);
		}

	}

	function Place_handle_json(json) {

		console.log(json); 

		$('#Place').text("");
		$('#n_pl').text("");
		
		var i = 0;

		$.each(
			json['results']['bindings'],
			function (index, value) {
				var place = ""; /*Inserisci VALUE TIPOLOGIA*/
				var graph = value['graph']['value'];
				var graph_name = rewrite_graph(graph);

				place += /*INIZIO DIV*/ '<div class="row res"><div class="col-8">' + graph_name + '<br />' +
				'<a href=' + value['subject']['value'] + ' target="_blank">' + value['label']['value'] + '</a></div>' +
				'<div class="col"><button type="button" id="' + value['subject']['value'] + '" class="luogo btn btn-default" alt="luogo" title="' + 
				value['label']['value'] + '"><i class="fa fa-map"></i><p class="btn-text">Scheda Luogo</p></button></div>' +
				'<div class="col"><button type="button" id="' + value['subject']['value'] + '" class="cit btn btn-default" alt="scheda" title="Info"><i class="fa fa-quote-right"></i><p class="btn-text">Citazione</p></button></div>' +
				/*DA QUI HYPERLINK ->*/'<div class="col"><button type="button" id="' + value['subject']['value'] + '" class="hyp btn btn-default" alt="scheda" title="Info"><i class="fa fa-link"></i><p class="btn-text">Hyperlink</p></button></div>' +
				/*DA QUI LOD ->*/'<div class="col"><a href="http://dev.restore.ovi.cnr.it/lodlive/?' + value['subject']['value'] + '" target="_blank"><button type="button" class="btn btn-default info" alt="LOD"><i class="fa fa-share-alt"></i><p class="btn-text">Lod</p></button></a></div></div>'; 

				i++;

				/*onclick=copy__Text("' + value['link']['value'] + '")*/

				$('#Place').append(place);

			});

		$('#n_pl').append(i);

		if (i==0) {
			var message = '<p>Nessun Luogo trovato</p>';
			$('#Place').append(message);
		}

	}

	$('#ClipArt1').click(function () {
		testo = $('input#TextArea1').val();
		results_retrieveData();
		search_name = "";
	});
  
    $('input#TextArea1').keypress(function(e) {
      var key = e.which;
      if (key == 13) // the enter key code
          {
            $('#ClipArt1').click();
            return false;
          }
    });

	//onlick hyperlink button

	$(document).on("click", ".hyp", function (ev) {

		var link = this.id;
		//alert(nome_autore);
		//$('#myModal').text("");
		$("#myModal").empty();
		$("#myModal").css("display", "block");
		$('#myModal').append("<div class='modal-content'><span class='close'>&times;</span><div id='myInput'>" +
			link + "</div><button id='copy_btn' class='btn btn-primary btn-lg' onclick='myFunction()'>Copia</button>");

		

	});

	$(document).on("click", ".lettera", function (ev) {

		var link = this.id;
		//alert(nome_autore);
		//$('#myModal').text("");
		window.open("lettera.html?link="+this.id);
		

	});

	$(document).on("click", ".object", function (ev) {

		var link = this.id;
		//alert(nome_autore);
		//$('#myModal').text("");
		window.open("object.html?link="+this.id);
		

	});

	$(document).on("click", ".artwork", function (ev) {

		var link = this.id;
		//alert(nome_autore);
		//$('#myModal').text("");
		window.open("OA.html?link="+this.id);
		

	});

	$(document).on("click", ".persona", function (ev) {

		var link = this.id;
		//alert(nome_autore);
		//$('#myModal').text("");
		window.open("Persona.html?link="+this.id);
		

	});

	$(document).on("click", ".luogo", function (ev) {

		var link = this.id;
		//alert(nome_autore);
		//$('#myModal').text("");
		window.open("Luogo.html?link="+this.id);
		

	});

	$(document).on("click", ".close", function (ev) {

		var link = this.id;
		//alert(nome_autore);
		//$('#myModal').text("");
		$("#myModal").css("display", "none");

	});

	$(document).on("click", ".back", function (ev) {

		$("#myTab").css("display", "none");

	});

	$(document).on("click", ".cit", function (ev) {
		
		var author ="RESTORE. smart access to digital heritage and memory"

		var year = new Date().getFullYear()

		var today = new Date();
		var dd = String(today.getDate()).padStart(2, '0');
		var mm = String(today.getMonth() + 1).padStart(2, '0'); //January is 0!
		var yyyy = today.getFullYear();

		today = dd + '/' + mm + '/' + yyyy;

		var link = this.id;
		//alert(nome_autore);
		//$('#myModal').text("");
		$("#myModal").empty();
		$("#myModal").css("display", "block");
		$('#myModal').append("<div class='modal-content'><span class='close'>&times;</span><div id='myInput'>" + 
			author + " " + year + ", accesso effettuato: " + today + ", &lt;" + link + "&gt;</div><button id='copy_btn' class='btn btn-primary btn-lg' onclick='myFunction()'>Copia</button>");

		

	});

	$(document).on("click", ".scheda", function (ev) {

		var link = this.id;
		var title = this.title;

		//alert(nome_autore);
		$("#myTab").empty();
		$("#myTab").css("display", "block");
		$('#myTab').append("<div class='tab-content'><span class='back'>&lt; Indietro</span><br /><h2><a href='" + link + "' target='_blank'>" + title + "</a></h2><div id='tab_container'><h3>Relazioni dirette</h3><br /><table id='info_link' class='table table-hover'></table><br /><table id='info_ico' class='table table-hover'></table><br /><h3>Relazioni inverse</h3><br /><table id='info_obj' class='table table-hover'></table></div></div>");

		/*var query_a = 'SELECT DISTINCT ?label WHERE { {<' + link +
		 '> ?p ?object. OPTIONAL {?object ?property ?label . FILTER(?property = <http://www.w3.org/2004/02/skos/core#prefLabel> || ?property = <http://www.w3.org/2000/01/rdf-schema#label>) FILTER (langMatches( lang(?label), "en" )) } } UNION {<'+ link +
		 '> ?p ?object. OPTIONAL {?p <http://www.w3.org/2000/01/rdf-schema#label> ?propertyLabel .?object <http://www.w3.org/2000/01/rdf-schema#label> ?label } FILTER (?p != <http://www.w3.org/1999/02/22-rdf-syntax-ns#type>) FILTER (langMatches( lang(?propertyLabel), "en" ))  }}';
		*/
		var query_a = 'SELECT DISTINCT ?propLab ?object ?label WHERE {{<' + link + 
		'> ?property ?object. ?property <http://www.w3.org/2000/01/rdf-schema#label> ?propLab . OPTIONAL {?object <http://www.w3.org/2000/01/rdf-schema#label> ?label . } FILTER (?property != <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> && ?property != <http://www.cidoc-crm.org/cidoc-crm/P62_depicts>) FILTER (langMatches( lang(?propLab), "en" ))} UNION {<' + link + 
		'> ?property ?object. ?property <http://www.w3.org/2000/01/rdf-schema#label> ?propLab . OPTIONAL {?object <http://www.w3.org/2000/01/rdf-schema#label> ?label . } FILTER (?property != <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> && ?property != <http://www.w3.org/2000/01/rdf-schema#label>) FILTER(!regex(?property, "cidoc"))}}';
		var object_url_a = 'http://dev.restore.ovi.cnr.it:8890/sparql/?default-graph-uri=&query=' + encodeURIComponent(query_a) + '&output=json';

		var query_b = 'SELECT DISTINCT ?subject ?label ?property ?propertyLabel WHERE {?subject ?property <' + link + 
		'> ; <http://www.w3.org/2000/01/rdf-schema#label> ?label . ?property <http://www.w3.org/2000/01/rdf-schema#label> ?propertyLabel . FILTER (langMatches( lang(?propertyLabel), "en" ))}';
		var object_url_b = 'http://dev.restore.ovi.cnr.it:8890/sparql/?default-graph-uri=&query=' + encodeURIComponent(query_b) + '&output=json';

		var query_c = 'SELECT DISTINCT ?object ?label WHERE {{<' + link + '> <http://www.cidoc-crm.org/cidoc-crm/P62_depicts> ?object . ?object <http://www.w3.org/2000/01/rdf-schema#label> ?label .} UNION {<' + link + 
		'> <http://www.cidoc-crm.org/cidoc-crm/P62_depicts> ?object . ?object <http://www.w3.org/2004/02/skos/core#prefLabel> ?label . FILTER (langMatches(lang(?label), "it" )) }}';
		var object_url_c = 'http://dev.restore.ovi.cnr.it:8890/sparql/?default-graph-uri=&query=' + encodeURIComponent(query_c) + '&output=json';


		$.ajax({//SOGGETTO

			url: object_url_a + '&callback=?',
			dataType: "json",
			success: function (data_a) {
				object_info_a(data_a);
			},
			error: function (e) {}
		});

		$.ajax({//OGGETTO

			url: object_url_b + '&callback=?',
			dataType: "json",
			success: function (data_b) {
				object_info_b(data_b);
			},
			error: function (e) {}
		});

		$.ajax({//ICONCLASS

			url: object_url_c + '&callback=?',
			dataType: "json",
			success: function (data_c) {
				object_info_c(data_c);
			},
			error: function (e) {}
		});
		
	});

	function object_info_a(json) {

		console.log(json); 

		var j = 0;

		$('#info_link').text("");

		$.each(
			json['results']['bindings'],
			function (index, value) {
				var autore_a = "";
				var object = "";
				var object_type = value['object']['type'];
				if (object_type == "typed-literal" || object_type == "literal"){
					object = '<td>'+ value['object']['value'] + '</td>';
				}
				else{
					object = '<td style="width:60%;"><a href="'+ value['object']['value'] +'" target="_blank">'+ value['label']['value'] +'</a></td><td>' +
					'<button type="button" id="' + value['object']['value'] + '" class="scheda btn btn-default" alt="scheda" title="' + value['label']['value'] + '"><i class="fa fa-bars"></i><p class="btn-text">Scheda</p></button></td><td>' +
					'<a href="http://dev.restore.ovi.cnr.it/lodlive/?' + value['object']['value'] + '" target="_blank"><button type="button" id="lod " class="btn btn-default info" alt="scheda" title="Info"><i class="fa fa-share-alt"></i><p class="btn-text">Lod</p></button></a></td>';
				}

				autore_a += /*INIZIO DIV*/ '<tr><td style="width:25%;">' + value['propLab']['value'] + '</td>' + object + '</tr>';/*FINE DIV*/ 

				/*onclick=copy__Text("' + value['link']['value'] + '")*/
				j++;

				$('#info_link').append(autore_a);

			});

		if (j==0) {
			var message_a = '<tr id="error"><td><p>Non sono presenti relazioni dirette per questa risorsa</p></td></tr>';
			$('#info_link').append(message_a);
		}

	}
	
	function object_info_b(json) {

		console.log(json); 

		var k = 0;

		$('#info_obj').text("");

		$.each(
			json['results']['bindings'],
			function (index, value) {

				var autore_b = "";

				autore_b += /*INIZIO DIV*/ '<tr><td style="width:60%;"><a href="' + value['subject']['value'] + '" target="_blank">' + value['label']['value'] + '</a></td><td style="width:25%;">' + value['propertyLabel']['value'] + '</td><td>' + 
				'<button type="button" id="' + value['subject']['value'] + '" class="scheda btn btn-default" alt="scheda" title="' + value['label']['value'] + '"><i class="fa fa-bars"></i><p class="btn-text">Scheda</p></button></td><td>' +
				'<a href="http://dev.restore.ovi.cnr.it/lodlive/?' + value['subject']['value'] + '" target="_blank"><button type="button" id="lod " class="btn btn-default info" alt="scheda" title="Info"><i class="fa fa-share-alt"></i><p class="btn-text">Lod</p></button></a></td></tr>';
				/*FINE DIV*/ 

				k++;
				/*onclick=copy__Text("' + value['link']['value'] + '")*/

				$('#info_obj').append(autore_b);

			});

		if (k==0) {
			var message_b = '<tr id="error"><td><p>Non sono presenti relazioni inverse per questa risorsa</p></td></tr>';
			$('#info_obj').append(message_b);
		}

	}

	function object_info_c(json) {

		console.log(json); 

		$('#info_ico').text("");

		$.each(
			json['results']['bindings'],
			function (index, value) {

				var autore_c = "";

				autore_c += /*INIZIO DIV*/ '<tr><td style="width:25%;">depicts</td><td style="width:60%;"><a href="' + value['object']['value'] + '">' + value['label']['value'] + '</a></td><td>' + 
				'<button type="button" id="' + value['object']['value'] + '" class="scheda btn btn-default" alt="scheda" title="' + value['label']['value'] + '"><i class="fa fa-bars"></i><p class="btn-text">Scheda</p></button></td><td>' +
				'<a href="http://dev.restore.ovi.cnr.it/lodlive/?' + value['object']['value'] + '" target="_blank"><button type="button" id="lod " class="btn btn-default info" alt="scheda" title="Info"><i class="fa fa-share-alt"></i><p class="btn-text">Lod</p></button></a></td></tr>';
				/*FINE DIV*/ 

				/*onclick=copy__Text("' + value['link']['value'] + '")*/

				$('#info_ico').append(autore_c);

			});

	}

	//VISUALIZZAZIONI DATI DELL'AUTORE
	

	//FUNZIONE LETTURA LUNGHEZZA FILE JSON
	/*
	function objLength(obj){
		var i=0;
		for (var x in obj){
		if(obj.hasOwnProperty(x)){
		  i++;
		}
		} 
		return i;
	}
	*/

	//#######################################
});

function copyToClipboard(text) {
    var sampleTextarea = document.createElement("textarea");
    document.body.appendChild(sampleTextarea);
    sampleTextarea.value = text; //save main text in it
    sampleTextarea.select(); //select textarea contenrs
    document.execCommand("copy");
    document.body.removeChild(sampleTextarea);
}

function myFunction(){
    var copy = document.getElementById("myInput");
    copyText = copy.textContent;
    copyToClipboard(copyText);

    //copyToClipboard(copyText.value);
}

